%------------------------------------------------%
%  UAV_q_1_FunctionvalueSym.m                    %
%  Evaluates the the UAV model x_dot = f(x,u)    %
%  at the given state/controll variables values. %
%  Lars Arne Grimsland, spring 2012              %
%------------------------------------------------%

function f = UAV_q_1_FunctionvalueSym(x,u1,u2)
g=9.81;         % gravity constant
f=sym(zeros(4,1));   % preallocating [svn , 1]

% Note that model is implemented with 1-indexed variables
% due to MATLB indexing convention

f(1) = sym(x(3)*cos(x(4)));   % x1 - Position, North
f(2) = sym(x(3)*sin(x(4)));   % x2 - Position, east
f(3) = sym(u1);               % x3 - UAV (vind)speed, u1 = commanded acc.
f(4) = sym(g*tan(u2)/x(3));   % x4 - UAV heading angle, u2 = bank angleend
