%%  - Hessian of objective - %%
% added to Hessian of constraints later on

% objective hessian scaled with obj_factor in IPOPT
hess_obj   = obj_factor*jacobian(jac_obj,x)
hess_obj_c = ccode(hess_obj)


%% - Hessian of Lagrangian - Nabla^2 f(x) + sum( lambda Nabla^2 g(x)  ) 
disp('Hessian of Lagrangian:')
disp('\nabla^2f(x) + l1 \nabla^2 g1(x) + l2 \nabla^2 g1(x) + ...')
disp('Hessian of objective function')
disp(' Found by taking jacobian of each row in jacobian of g vector ')

%% - Options for moving / overlaping blocks

index_incr = ovn; %increase in variable index and col/row pos foreach block
lagr_incr  = svn;
hess_block_nonz=hnb;

% c-style index of overlaping functions (spare/value-format)

% index of overlaping functions in hessian block
% 0-index, corresponding to position in VALUES-Vector of sparce format.
% most easily found by printing  the "visualiser" matrix below
%overlap_index = [16; 21;22; 27;28;29; 34;35;36;37; ]; % <- For quad obj
overlap_index = [17; 22;23; 28;29;30; 35;36;37;38;]; % <- For exp obj
%overlap_index:  indexes of overlapped nonzeroes in lower right quadrant
overlaping_h  = 10;% same for both quad and exp obj
%overlaping_h: number of nonzeros in upper left quadrant of hessain
hnba = hnb-overlaping_h; % 


%% - Creating 1st block of Lagrangian Hessian - %

sum_lagr_hess=zeros(ovn*2,ovn*2); %ovn*2 = opt vars pr block

lagrangemultipliers = [lambda0; lambda1; lambda2; lambda3; lambda4; lambda5 ]; % one lagrange mult. pr constr

for i=1:svn  % calculate and sum the constraint hessians of first segment
    row=jac_g_x(i,:); 
    hess_g_i=jacobian(row,x)*lagrangemultipliers(i);
    sum_lagr_hess=sum_lagr_hess+hess_g_i;
end
hessian_block = sum_lagr_hess + hess_obj




% Putting the hessian block information in 3 arrays as they are used in 
% the C++/IPOPT opitmization application; values(functions), Row, Col.
% See IPOPT doc for details on spare matrix representation
values = [] ;
iRow = [] ;
jCol = [] ;
hess_nonz_count=0;

%% Hessian visualization, finding parameters %%
% Making a matrix for easier visualization of Hessina block 
% Simplifies finding overlaping functions in Hessian blocks (se report)
visualizer = zeros(2*ovn,2*ovn);
for i = 1:ovn*2
    for j = 1:i 
       if ( hessian_block(i,j) ~= 0 ) % If nonzero, put in matrices
           values = [values; hessian_block(i,j); ];
           iRow = [iRow; i-1;]; %
           jCol = [jCol; j-1;]; % 
           hess_nonz_count = hess_nonz_count+1;
           
           visualizer(i,j)=888;
           % NONZEROS displayed as '888'
       end
    end    
end

visualizer

disp('Number of Hessian nonzeros in 0th block - hnb')
hnb = hess_nonz_count % Hessian Nonzeros in a single block
hnb_str=int2str(hnb);  % Hessian Nonzeros in a single block, string
disp('Number of appended Hessian nonzeros after 0th block - hnba ')
hnba=hnb-overlaping_h
hnba_str=int2str(hnba);

%% - Writing indices of Hessian nonzeros to file (Multiple Blocks) - %%

hess_pos_id = fopen(hesspos_path, 'w'); % making shure file is empty
fclose(hess_pos_id);
hess_pos_id = fopen(hesspos_path, 'at'); % appending when writing


for s = 1:segments    % s counts segments
    for i = 1:hnb     % i counts position in block array, hess Nonnz in Blo
       
       if s==1
            number1 = int2str(iRow(i));   % value of iRow(i) casted to string
            index = int2str(i-1);           % correcting to c-style indexing  
            stringtest = strcat( 'iRow[',index,'] = ' , number1 ,'; \n' );
            fprintf(hess_pos_id, stringtest ); %, jac_iRow_c);  % \n : new line
        
            number2 = int2str(jCol(i));
            stringtest2 = strcat( 'jCol[',index,'] = ' , number2 ,'; \n' );
            fprintf(hess_pos_id, stringtest2 );
   
            fprintf(hess_pos_id, '\n' );
        elseif s>1 && i<=overlaping_h
            %nothing is done during overlap
        else
            index = int2str( i-1 + (s-1)*(hnb-overlaping_h) ); % correcting to c-style indexing  
            
            row_pos = int2str(iRow(i)+(s-1)*index_incr );   % value of iRow(i) casted to string
            stringtest = strcat( 'iRow[',index,'] = ' , row_pos ,'; \n' );
            fprintf(hess_pos_id, stringtest ); %, jac_iRow_c);  % \n : new line
        
            col_pos = int2str(jCol(i)+(s-1)*index_incr);
            stringtest2 = strcat( 'jCol[',index,'] = ' , col_pos ,'; \n' );
            fprintf(hess_pos_id, stringtest2 );
   
            fprintf(hess_pos_id, '\n' );
        end 
        
    end
    fprintf(hess_pos_id, '\n\n /* segment done */ \n\n' );
end
fclose(hess_pos_id);

%% - Writing values of Hessian nonzeros to file (SINGLE BLOCK)  - %%
%% - Hessian Values VERSION 2  - %%

fid = fopen(hessval2_path, 'w'); % making shure file is empty
fclose(fid);
fid = fopen(hessval2_path, 'at'); % appending when writing
for k=1:hnb   % k counts line in value-array. hnb: Hess Nonzeros in Block
    symb_line = values(k); % copy symbolic eq at line k in array
    c_string  = ccode(symb_line);    % casting symbolic eq to C
    
    valuebase = strcat('valuebase[', int2str(k-1),']' );
    c_string  = strrep(c_string, 't0 ', valuebase); % removing index created when casting t c
    
    fprintf(fid, c_string);
    fprintf(fid, '\n ');
end
fclose(fid);