%% - Objective function gradient/jacobian  setup - %%

% exact (symbolic differentiation) of objective for first block
jac_obj = jacobian(objective,x)

%opening empty file for writing
fid = fopen(obj_jac_path, 'w');
fclose(fid);
fid = fopen(obj_jac_path, 'at');

% writing jacobian for all blocks in c-sytax to file%
disp(' ENTERING OBJ_JAC LOOP -------------------------------------------')

for k=0:(segments-1)
    for i = 1:ovn*2 % ovn*2 = number of opt. vars in a bolck/segment
        s           = jac_obj(i);
        pos         = i-1+k*ovn;
        index       = num2str(pos);
        stringen    = ccode(s);
        modifiedStr = strrep(stringen, 't0 = ', ' ');  % remove name
        % correcting variable names/indexes to C-style.
        % All variable indices increases with 6 for each block
        
        newVar= strcat( 'x[10+', int2str(k*ovn), ']' );
        modifiedStr  = strrep(modifiedStr, 'x10', newVar );
        newVar= strcat( 'x[11+', int2str(k*ovn), ']' );
        modifiedStr  = strrep(modifiedStr, 'x11', newVar );
                
        newVar= strcat( 'x[1+', int2str(k*ovn), ']' );
        modifiedStr  = strrep(modifiedStr, 'x1', newVar );
        newVar= strcat( 'x[2+', int2str(k*ovn), ']' );
        modifiedStr  = strrep(modifiedStr, 'x2', newVar );
        newVar= strcat( 'x[3+', int2str(k*ovn), ']' );
        modifiedStr  = strrep(modifiedStr, 'x3', newVar );
        newVar= strcat( 'x[4+', int2str(k*ovn), ']' );
        modifiedStr  = strrep(modifiedStr, 'x4', newVar );
        newVar= strcat( 'x[5+', int2str(k*ovn), ']' );
        modifiedStr  = strrep(modifiedStr, 'x5', newVar );
        newVar= strcat( 'x[6+', int2str(k*ovn), ']' );
        modifiedStr  = strrep(modifiedStr, 'x6', newVar );
        newVar= strcat( 'x[7+', int2str(k*ovn), ']' );
        modifiedStr  = strrep(modifiedStr, 'x7', newVar );
        newVar= strcat( 'x[8+', int2str(k*ovn), ']' );
        modifiedStr  = strrep(modifiedStr, 'x8', newVar );
        newVar= strcat( 'x[9+', int2str(k*ovn), ']' );
        modifiedStr  = strrep(modifiedStr, 'x9', newVar );
        
        if k==0     % First block
            val_index = int2str(i-1);
            modifiedStr = strcat( 'grad_f[',val_index,'] = ' , modifiedStr, ' \n' );
        elseif i<=ovn
            % Overlap; +=
            val_index = int2str(i-1 + k*ovn);
            modifiedStr = strcat( 'grad_f[',val_index,'] += ' , modifiedStr, ' \n' );
        else        % Append; =
            val_index = int2str(i-1 + k*ovn);
            modifiedStr = strcat( 'grad_f[',val_index,'] = ' , modifiedStr, ' \n' );
        end
        
        fprintf(fid, modifiedStr);
    end
    fprintf(fid, '\n  /* --- Next Block --- */ \n');
end

fclose(fid);