%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%  UAV_q_1_startpoint.m : 
% Generates a feasible startpoint for % IPOPT/C++ app.
% Simulating a fligh with a RK4 method. All inputs are zero
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

disp('Simulation to find optimization start point begun')

acc_inputs  = 0; % input = 0 in all NODES
bank_inputs = 0;

% Values, 0th node - NOT Inputs
y0 = [x0;x1;x2;x3;];
%x0,x1,.. defined as symbols in UAV_q_1_MAIN_ProblemSetup.m

%% Calling RK4 method
y_start = sym( UAV_q_1_RK4_SV(y0, acc_inputs, bank_inputs, T) );
% Tnum defined in ProblemSetupFile

% the returned y is a [ svn x 1 ] array, with symbolic expression for node1 
% NOTE: Inputs are not returned! And are added  by hardcode below
% Code is generalised to calculate all nodes in c-progam

%% Printing startpoints to file
disp('Optimization start point simulated, starting writing process')

fids = fopen(startval_path, 'w');
fclose(fids);
fid = fopen(startval_path, 'at');

for i=1:svn
   cindex = num2str(i-1+ovn);
   translate = y_start(i);
   trString  = ccode(translate);
   trString  = strrep(trString,'t0 =', '');
   trString  = strcat('x',cindex, ' = ', trString, '\n');
   
   fprintf(fid, trString);
end
% ADDING INPUTS VARIABLES FOR THE FIRST NODE
fprintf(fid, 'x10=0;\n');
fprintf(fid, 'x11=0;\n\n');

fclose(fid);
disp('Optimization start point written ...')

