%% - Constraints jacobian- %% 

%   Sparsity structure of Jacobian of constraints
%   disp('Jacobian of first defects / Constraints, J = delta_d(x) - one by one' )
jac_g_x = jacobian(g , x)

size_matrix=size(jac_g_x)
jac_bl_row = size_matrix(1);
jac_bl_col = size_matrix(2);

j_g_values = [] ;
j_g_iRow = [] ;
j_g_jCol = [] ;
jac_nonz_counter = 0;

for i = 1:jac_bl_row % from/including - to/including
   for j = 1:jac_bl_col
      if ( jac_g_x(i,j) ~= 0 )
        j_g_values = [j_g_values;jac_g_x(i,j);];
        j_g_iRow = [j_g_iRow; i-1 ];    % -1 to get correct C-style index
        j_g_jCol = [j_g_jCol; j-1];       % index adjusted to C-style in loop header
        jac_nonz_counter = jac_nonz_counter+1;
      end
   end
end

disp('Number of Nonzeros in a Constraint Jacobian Block - jnb:')
jnb = jac_nonz_counter
jnb_str = num2str(jnb);

% Creating C-code for values of jacobian, printing to FILE %

fid = fopen(JacVal_path, 'w');
fclose(fid);
fid = fopen(JacVal_path, 'at');

for i = 1:jnb % JNB - number of Jacobian Nonzeros in Block
    jgvstr = j_g_values(i); %get nonzero fcn from array
    index = num2str(i-1);   % correct block index , c-style
    stringen = ccode(jgvstr); % cast nonzero  fcn to c-code
    str_u_ind = strrep(stringen, 't0 = ', ' '); %removing matlab index 
    jac_g_nonz = strcat( 'values[',index,'+',jnb_str,'*i] = ' , str_u_ind ,' \n' );
    fprintf(fid, jac_g_nonz);
end
fclose(fid);

%   NOTE!   Only first jacobian block is written to file.
%           For loop in C app where #including writes all blocks of jac_g.
%           In IPOPT: x[n] -> x[n+s*7]


% Creating C-code for jacobian indexing, sparse matrix format %

fid = fopen(JacPos_path, 'w'); % making shure file is empty
fclose(fid);
fid = fopen(JacPos_path, 'at'); % appending when writing

for i = 1:jnb % JNB - Jacobian Nonzeros in Block
   index = int2str(i-1);        % correcting to c-style indexing  
   
   iRow_pos = int2str(j_g_iRow(i));   % value of iRow(i) casted to string
   stringtest = strcat( 'iRow[',index,'+',jnb_str,'*i] = ', iRow_pos,'+i*',svn_str,'; \n' );
   fprintf(fid, stringtest ); %, jac_iRow_c);  % \n : new line
    
   jCol_pos = int2str(j_g_jCol(i));
   stringtest2 = strcat( 'jCol[',index,'+',jnb_str,'*i ] = ' , jCol_pos ,'+i*',ovn_str,'; \n' );
   fprintf(fid, stringtest2 );
   
   fprintf(fid, '\r\n' );
end

fclose(fid);

% NB!   Only first block written to file. Indexes generalized to fit with
%       for-loop in C app.
%       Remember block structure, explained in report  
