%------------------------------------------------%
%  Functionvalue5st.m                            %
%  Evaluates the the UAV model x_dot = f(x,u)   %
%  with the 2 unsertainty modeled                %
%  at the given state/controll variables values. %
%  Lars Arne Grimsland, spring 2012              %
%------------------------------------------------%

function f = Uct2_Functionvalue(x,u1,u2,alpha0,b0,ceta0,k0,T0e,T0n,alpha1,b1,ceta1,k1,T1e,T1n)
g=9.81;         % gravity constant
f=zeros(6,1);   % preallocating

beta0 = b0*exp( -k0*sqrt(  (T0n-x(1))^2 + (T0e-x(2))^2  ));
beta1 = b1*exp( -k1*sqrt(  (T1n-x(1))^2 + (T1e-x(2))^2  ));

f(1) = x(3)*cos(x(4));    % x1 - Position, North
f(2) = x(3)*sin(x(4));    % x2 - Position, east
f(3) = u1;                % x3 - UAV (vind)speed, u1 = commanded acc.
f(4) = g*tan(u2)/x(3);    % x4 - UAV heading angle, u2 = bank angle
f(5) = x(5)*(alpha0-beta0) + ceta0;
f(6) = x(6)*(alpha1-beta1) + ceta1;
end
