%------------------------------------------------%
%  Functionvalue5st.m                            %
%  Evaluates the the UAV model x_dot = f(x,u)   %
%  with the 2 unsertainty modeled                %
%  at the given state/controll variables values. %
%  Lars Arne Grimsland, spring 2012              %
%------------------------------------------------%

function f = Uct_FunctionvalueSym(x,u1,u2,alpha,b,ceta,k,Te,Tn,targets)
g=9.81;         % gravity constant
f=sym(zeros(4+targets,1));   % preallocating
beta=sym(zeros(targets,1));


for i=1:1:targets
    % preparing the beta-terms for uncertainty models
    beta(i) = sym( b(i)*exp( -k(i)*sqrt(  (Tn(i)-x(1))^2 + (Te(i)-x(2))^2  )));
end

% - Comment out unnused  %
f(1) = sym(x(3)*cos(x(4)));    % x0 - Position, North
f(2) = sym(x(3)*sin(x(4)));    % x1 - Position, east
f(3) = sym(u1);                % x2 - UAV (vind)speed, u1 = commanded acc.
f(4) = sym(g*tan(u2)/x(3));  % x3- UAV heading angle, u2 = bank angle
for i=1:1:targets
    % setting up uncertainty models
    f(4+i) = sym(x(4+i)*(alpha(i)-beta(i)) + ceta(i));
end

end
