%% - Objective Function setup - %%

%% - Defining Objective - %% 

syms Wa;     % wheight parameter, use of acceleration
syms Wr;     % wheight parameter, change in rudder
syms Wu0;    % wheight parameters, uncertainty reduction
syms Wu1 Wu2 Wu3 Wu4 Wu5 Wu6 Wu6 Wu7 Wu8    

% Objective Function for first block (IPOPT minimizes objective)
% starting from second node since variables in second node are fixed
if (targets == 1)
    objective = Wu0*x11 + Wa*(x12)^2 + Wr*(x13)^2 ; 
elseif(targets == 2)
    objective = Wu0*x12 + Wu1*x13 + Wa*(x14)^2 + Wr*(x15)^2 ;
elseif (targets ==4 )
    objective = Wu0*x14 + Wu1*x15 +  Wu2*x16 + Wu3*x17 + Wa*(x18)^2 + Wr*(x19)^2 ;
elseif(targets==9)
    objective = Wu0*x19 + Wu1*x20 +  Wu2*x21 + Wu3*x22 + Wu4*x23 + Wu5*x24 +  Wu6*x25 + Wu7*x26+ Wu8*x27 +Wa*(x28)^2 + Wr*(x29)^2 ;
end
disp('Objective Function initialized')

%% - Translating to generalized C-string - %%
objectiveStringC = ccode(objective);
objectiveStringC = strrep(objectiveStringC, 't0 = ', ''); % removing unnecessary name
objectiveStringC = strrep(objectiveStringC, ';', '');     % removing unnecessary ;

objectiveToWrite = ''; 

for i=0:segments-1 % variable index increase by OVN pr block
    incr = num2str(i*ovn); % 0,8,16,24... OVN - optimiz variables pr node 
    % correcting variable names/indexes to C-style.
    % All variable indices increases with (m+n) for each block
    modifiedStr  = objectiveStringC;    
    newVar1= strcat( 'x[11+', int2str(i*ovn), ']' );
    modifiedStr  = strrep(modifiedStr, 'x11', newVar1 );
    newVar2= strcat( 'x[12+', int2str(i*ovn), ']' );
    modifiedStr  = strrep(modifiedStr, 'x12', newVar2 );
    newVar3= strcat( 'x[13+', int2str(i*ovn), ']' );
    modifiedStr  = strrep(modifiedStr, 'x13', newVar3 );
    newVar4= strcat( 'x[14+', int2str(i*ovn), ']' );
    modifiedStr  = strrep(modifiedStr, 'x14', newVar4 );
    newVar5= strcat( 'x[15+', int2str(i*ovn), ']' );
    modifiedStr  = strrep(modifiedStr, 'x15', newVar5 );
    newVar5= strcat( 'x[16+', int2str(i*ovn), ']' );
    modifiedStr  = strrep(modifiedStr, 'x16', newVar5 );
    newVar5= strcat( 'x[17+', int2str(i*ovn), ']' );
    modifiedStr  = strrep(modifiedStr, 'x17', newVar5 );
    newVar5= strcat( 'x[18+', int2str(i*ovn), ']' );
    modifiedStr  = strrep(modifiedStr, 'x18', newVar5 );
    newVar5= strcat( 'x[19+', int2str(i*ovn), ']' );
    modifiedStr  = strrep(modifiedStr, 'x19', newVar5 );
    newVar5= strcat( 'x[20+', int2str(i*ovn), ']' );
    modifiedStr  = strrep(modifiedStr, 'x20', newVar5 );
    newVar5= strcat( 'x[21+', int2str(i*ovn), ']' );
    modifiedStr  = strrep(modifiedStr, 'x21', newVar5 );
    newVar5= strcat( 'x[22+', int2str(i*ovn), ']' );
    modifiedStr  = strrep(modifiedStr, 'x22', newVar5 );
    newVar5= strcat( 'x[23+', int2str(i*ovn), ']' );
    modifiedStr  = strrep(modifiedStr, 'x23', newVar5 );
    newVar5= strcat( 'x[24+', int2str(i*ovn), ']' );
    modifiedStr  = strrep(modifiedStr, 'x24', newVar5 );
    newVar5= strcat( 'x[25+', int2str(i*ovn), ']' );
    modifiedStr  = strrep(modifiedStr, 'x25', newVar5 );
    newVar5= strcat( 'x[26+', int2str(i*ovn), ']' );
    modifiedStr  = strrep(modifiedStr, 'x26', newVar5 );
    newVar5= strcat( 'x[27+', int2str(i*ovn), ']' );
    modifiedStr  = strrep(modifiedStr, 'x27', newVar5 );
    newVar5= strcat( 'x[28+', int2str(i*ovn), ']' );
    modifiedStr  = strrep(modifiedStr, 'x28', newVar5 );
    newVar5= strcat( 'x[29+', int2str(i*ovn), ']' );
    modifiedStr  = strrep(modifiedStr, 'x29', newVar5 );
    % Note! if more variables are added to objective - add more var-replace
    
    
    if  i ~= segments-1  % unless last segment, add a +
        objectiveToWrite = strcat(objectiveToWrite, modifiedStr, ' + ');
    else
        objectiveToWrite = strcat(objectiveToWrite, modifiedStr );
    end
end 

% adding variable declaration and end of line, as c-syntax rewuires
objectiveToWrite  = strcat( 'obj_value = ' , objectiveToWrite, ';' );

disp('Objective Function generaliced, parsed to C-Code')

%% - Write to file - %%
% writing objective function string to text file, ready to be included in
% the IPOPT C++ framework
% Object fcn string for ALL segments. No loop/editing in C app.

fid = fopen(objective_path, 'w');
fclose(fid);
fid = fopen(objective_path, 'at');
fprintf(fid, objectiveToWrite);
fclose(fid);

disp('Objective Function Written to file')