%%%
% UM_startpoint.m : Generates a feasible startpoint for % IPOPT/C++ app.
% Simulating a fligh with a RK4 method. All inputs are zero
%%%

disp('Simulation to find optimization start point begun')

acc_inputs  = 0; % input = 0 in all NODES
bank_inputs = 0;


%% Calling RK4 method
y_start = sym(Uct_RK4_SV(y0, acc_inputs, bank_inputs, T,alpha,b,ceta,k,Te,Tn,targets));
% Tnum defined in ProblemSetupFile

% the returned y is a [ svn*(segments+1) x 1 ] array, with with the value of
% the STATES in all nodes. when printing out to file, inputs must be added
% NOTE: Inputs are not returned!

%% Printing startpoints to file
disp('Optimization start point simulated, starting writing process')

fid = fopen(startval_path, 'w');
fclose(fid);
fid = fopen(startval_path, 'at');

for i=1:svn
   cindex = num2str(i-1+ovn);
   translate = y_start(i);
   trString  = ccode(translate);
   trString  = strrep(trString,'t0 =', '');
   trString  = strcat('x',cindex, ' = ', trString, '\n');
   
   fprintf(fid, trString);
end

% determining input variables name in c-style
u1_index = ovn*2-2;
u2_index = ovn*2-1;
u1posString = strcat('x',int2str(u1_index) ,'=0;\n');
u2posString = strcat('x',int2str(u2_index) ,'=0;\n');
fprintf(fid, u1posString);
fprintf(fid, u2posString);

fclose(fid);
disp('Optimization start point written ...')

