%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                                                                        %
%   Uct2NMPC_PlotSim.m                                                   %
%   Reads results from IPOPT program from text file,                     %
%   ADAPTED FOR THE NMPC with WIND  
%  
%                                                                        %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
clc;

%% Reading various PARMATETERS from optimization %%
parameter_id = fopen('C:\Users\grimslan\Dropbox\ShortFlight - 2ExpBell NMPC wind\Release\parameters.txt', 'r');
% Problem data %
tline = fgetl(parameter_id);
model_states = str2double(tline);
tline        = fgetl(parameter_id);
model_inputs = str2double(tline);
tline        = fgetl(parameter_id);
T            = str2double(tline);
tline        = fgetl(parameter_id);
RecalcNode   = str2double(tline);
	
% Uncertainty model 0 parameteres %
tline  = fgetl(parameter_id);
alpha0 = str2double(tline)  ;  
tline  = fgetl(parameter_id);
b0     = str2double(tline);
tline  = fgetl(parameter_id);
k0     = str2double(tline);
tline  = fgetl(parameter_id);
ceta0  = str2double(tline);
tline  = fgetl(parameter_id);
T0n    = str2double(tline);
tline  = fgetl(parameter_id);
T0e    = str2double(tline);

% Uncertainty model 1 parameteres %
tline = fgetl(parameter_id);
alpha1 = str2double(tline);
tline = fgetl(parameter_id);
b1 = str2double(tline);
tline = fgetl(parameter_id);
k1 = str2double(tline);
tline = fgetl(parameter_id);
ceta1 = str2double(tline);
tline = fgetl(parameter_id);
T1n = str2double(tline);
tline = fgetl(parameter_id);
T1e = str2double(tline);
	
% Objective function parametres %
tline = fgetl(parameter_id);
Wa = str2double(tline);
tline = fgetl(parameter_id);
Wr = str2double(tline);
tline = fgetl(parameter_id);
Wu0 = str2double(tline);
tline = fgetl(parameter_id);
Wu1 = str2double(tline);

fclose(parameter_id);


%% Reading optimization Result from file, sorting them %%

% _Not_ preallocating to make it as simple as possible
north_c      = [];       % Array of UAV North position coordinates
east_c       = [];          % Array of UAV East position coordinates
uav_speed    = [];       % Array of UAV air speeds
uav_heading  = [];     % Array of UAV headings
tar_uncert0  = [];      % Array of Ice field survailance information uncertainty
tar_uncert1  = [];
acceleration = [];    % Array of UAV input acceleration
bank_angle   = [];      % Array of UAV input banking angle
counter      = 0;

% From the first calculated path%
first_north_c      = [];       % Array of UAV North position coordinates
first_east_c       = [];          % Array of UAV East position coordinates
first_uav_speed    = [];       % Array of UAV air speeds
first_uav_heading  = [];     % Array of UAV headings
first_tar_uncert0  = [];      % Array of Ice field survailance information uncertainty
first_tar_uncert1  = [];
first_acceleration = [];    % Array of UAV input acceleration
first_bank_angle   = [];      % Array of UAV input banking angle

% From the first calculated path, corrected for wind disturbance %
wind_north_c      = [];       % Array of UAV North position coordinates
wind_east_c       = [];          % Array of UAV East position coordinates
wind_uav_speed    = [];       % Array of UAV air speeds
wind_uav_heading  = [];     % Array of UAV headings
wind_tar_uncert0  = [];      % Array of Ice field survailance information uncertainty
wind_tar_uncert1  = [];
wind_acceleration = [];    % Array of UAV input acceleration
wind_bank_angle   = [];      % Array of UAV input banking angle



%% Reading the continously updated MPC path %%

example_id = fopen('C:\Users\grimslan\Dropbox\ShortFlight - 2ExpBell NMPC wind\Release\opt_solution.txt', 'r');
while 1
    tline = fgetl(example_id);
    if ~ischar(tline), break, end
        x = str2double(tline);
        counter = counter+1;
        index = mod(counter,8)  % NOTe HARDCODE: (counter, "no of opt.vars. in node")
        if (index==1)
            north_c = [north_c;x;];
        elseif (index==2)
            east_c = [east_c;x;];
        elseif (index==3)
            uav_speed = [uav_speed; x;];
        elseif (index==4)
            uav_heading = [uav_heading; x;];
        elseif (index==5)
            tar_uncert0 = [tar_uncert0;x;];
        elseif (index==6)
            tar_uncert1 = [tar_uncert1;x;];
         elseif (index==7)
            acceleration = [acceleration;x;];
        elseif (index==0)
            bank_angle = [bank_angle;x;];
        else
                disp('unecspected occurance while sorting results')
        end
            
end    
fclose(example_id);

%% Reading in first / "original" path

%example_id = fopen('C:\Users\lars.grimsland\Dropbox\ShortFlight - 2ExpBell NMPC\Debug\example2.txt', 'r');
example_id = fopen('C:\Users\grimslan\Dropbox\ShortFlight - 2ExpBell NMPC wind\Release\first_optim.txt', 'r');
while 1
    tline = fgetl(example_id)
    if ~ischar(tline), break, end
        x = str2double(tline)
        counter = counter+1;
        index = mod(counter,8)
        if (index==1)
            first_north_c = [first_north_c;x;];
        elseif (index==2)
            first_east_c = [first_east_c;x;];
        elseif (index==3)
            first_uav_speed = [first_uav_speed; x;];
        elseif (index==4)
            first_uav_heading = [first_uav_heading; x;];
        elseif (index==5)
            first_tar_uncert0 = [first_tar_uncert0;x;];
        elseif (index==6)
            first_tar_uncert1 = [first_tar_uncert1;x;];
         elseif (index==7)
            first_acceleration = [first_acceleration;x;];
        elseif (index==0)
            first_bank_angle = [first_bank_angle;x;];
        else
                disp('unecspected occurance while sorting results')
        end
            
end    
fclose(example_id);

%% Reading First path, corrected for wind influence

%example_id = fopen('C:\Users\lars.grimsland\Dropbox\ShortFlight - 2ExpBell NMPC\Debug\example2.txt', 'r');
example_id = fopen('C:\Users\grimslan\Dropbox\ShortFlight - 2ExpBell NMPC wind\Release\first_optim_with_disturbance.txt', 'r');
while 1
    tline = fgetl(example_id)
    if ~ischar(tline), break, end
        x = str2double(tline)
        counter = counter+1;
        index = mod(counter,8)
        if (index==1)
            wind_north_c = [wind_north_c;x;];
        elseif (index==2)
            wind_east_c = [wind_east_c;x;];
        elseif (index==3)
            wind_uav_speed = [wind_uav_speed; x;];
        elseif (index==4)
            wind_uav_heading = [wind_uav_heading; x;];
        elseif (index==5)
            wind_tar_uncert0 = [wind_tar_uncert0;x;];
        elseif (index==6)
            wind_tar_uncert1 = [wind_tar_uncert1;x;];
         elseif (index==7)
            wind_acceleration = [wind_acceleration;x;];
        elseif (index==0)
            wind_bank_angle = [wind_bank_angle;x;];
        else
                disp('unecspected occurance while sorting results')
        end
            
end    
fclose(example_id);


%% Plotting the sorted results %%
temp=size(north_c);
N=temp(1);  % N: number of nodes
flytime=(N-1)*T;
timescaler=0:T:(N-1)*T ;


%Plot the optimal path
figure(2)
    plot(east_c,north_c, 'b-o', 'LineWidth', 2);
    title(['Optimal Path w/' num2str(N-1),' nodes and ', num2str(flytime), ' sec flight time.']) ;
    xlabel('Metres East, [m]');
    ylabel('Metres North, [m]');
    grid on;
    hold on;
    plot(first_east_c,first_north_c, 'r-o', 'LineWidth', 2);
    plot(wind_east_c,wind_north_c, 'g-o', 'LineWidth', 2);
    plot(100, 100, 'm-*', 'LineWidth', 7);
    plot(100, 150, 'm-*', 'LineWidth', 7);
    legend('UAV path w/MPC','First calculated Path','First calculated Path influenced by wind','Targets', 'Location', 'SouthEast');
    hold off
    
% Plot other optimized variables    
figure( 3)    
    subplot(2,1,1),plot(timescaler, uav_heading, 'b-o','LineWidth', 2),title('Heading; (0 degrees = North, 90 degrees = East- )');
        xlabel('Time, [s]');
        ylabel('Heading, [degrees]');
        grid on
    subplot(2,1,2),plot(timescaler,uav_speed, 'b-o', 'LineWidth', 2),title('Groundspeed');
        xlabel('Time, [s]');
        ylabel('Speed, [m/s]');
        grid on
figure(4)    
    subplot(2,1,1)
        stairs(timescaler,acceleration, 'b-o','LineWidth', 2),title('u1 - commanded acceleration');
        xlabel('Time, [s]')
        ylabel('Acceleration, [m/s^2]')
        grid on
    subplot(2,1,2)
        stairs(timescaler,bank_angle, 'b-o','LineWidth', 2), title('u2 - commanded bank angle');
        xlabel('Time, [s]')
        ylabel('Bank angle, [degrees]')
        grid on
figure(5) % Plotting Graphs of uncertainties in the same figure
        stairs(timescaler,tar_uncert0, 'b-o','LineWidth', 2), title('Information Uncertainty of Targets');
        xlabel('Time, [s]')
        ylabel('Uncertainty')
        grid on
        hold on
        stairs(timescaler,tar_uncert1, 'r-o','LineWidth', 2)
        legend('x5 - Uncertainty, Target 0','x6 - Uncertainty, Target 1', 'Location', 'NorthEast')
        grid on
        hold off
