
/*
	Parameters for the optimization problem are gathered here.
	Lars Grimsland, spring 2012
*/


#include "parameters.h"
#include "cmath"



/* Problem parameters */
int segments = 60;		// no of segments in flight path
/* NOTE! no of segments must coincide with MATLAB script!!! */
int targets = 4;
int StateVarsNode = 4+targets;	// no of variables in state space model
int InputVarsNode = 2;	// no of iputs in state space model
int conJacNonZ = 72;	// no of nonzeros in a jacobian block 46,52,72
int HessNonzFirst = 126;	// nonzeros in first hessian block 1tg:78, 2tg:94 4tg:126 - 9tg:
int HessNonzApp = 93;		// nonzeros added by following blocks 57,69,93
int	HessNoOverlaps = 33;	// number of overlaping elements in Hessian blocks 1tg:21; 2tg:25, 4tg:33

int HessOverlapIndex[33] = {41, 50,51, 62,63,64, 75,76,77,78, 83,84,85,86, 91,92,93,94, 99,100,101,102, 107,108,109,110, 115,116,117, 122,123,124,125}; 
// int	HessOverlapIndex[21] = { 26, 32,33, 41,42,43, 51,52,53,54, 59,60,61,62, 67,68,69, 74,75,76,77}; 
// int	HessOverlapIndex[25] = {31, 38,39, 48,49,50, 59,60,61,62, 67,68,69,70, 75,76,77,78, 83,84,85, 90,91,92,93}; 
// returns the index of the indext'th overlaping element

double grav = 9.81;	   // gravity
double T = 1.0;          // segment lengt in seconds

/* Disturbances / updated info */
double windSpeedNorth=2;
/* Uncertainty Model Parameteres - Target 0 */
double alpha0 = 0.0;
double b0 = 5.0;
double k0 = 0.02;
double ceta0 = 100;
double T0n = 100.0;
double T0e = 100.0;
/* Uncertainty Model Parameteres - Target 1 */
double alpha1 = 0.0;
double b1 = 5.0;
double k1 = 0.02;
double ceta1 = 100;
double T1n = 150.0;
double T1e = 100.0;
/* Uncertainty Model Parameteres - Target 2 */
double alpha2 = 0.0;
double b2 = 5.0;
double k2 = 0.02;
double ceta2 = 100;
double T2n = 100.0;
double T2e = 150.0;
/* Uncertainty Model Parameteres - Target 3 */
double alpha3 = 0.0;
double b3 = 5.0;
double k3 = 0.02;
double ceta3 = 100;
double T3n = 150.0;
double T3e = 150.0;
/* Uncertainty Model Parameteres - Target 4 */
double alpha4 = 0.0;
double b4 = 5.0;
double k4 = 0.02;
double ceta4 = 100;
double T4n = 100.0;
double T4e = 200.0;
/* Uncertainty Model Parameteres - Target 5 */
double alpha5 = 0.0;
double b5 = 5.0;
double k5 = 0.02;
double ceta5 = 100;
double T5n = 150.0;
double T5e = 200.0;
/* Uncertainty Model Parameteres - Target 6 */
double alpha6 = 0.0;
double b6 = 5.0;
double k6 = 0.02;
double ceta6 = 100;
double T6n = 200.0;
double T6e = 200.0;
/* Uncertainty Model Parameteres - Target 7 */
double alpha7 = 0.0;
double b7 = 5.0;
double k7 = 0.02;
double ceta7 = 100;
double T7n = 200.0;
double T7e = 150.0;
/* Uncertainty Model Parameteres - Target 8 */
double alpha8 = 0.0;
double b8 = 5.0;
double k8 = 0.02;
double ceta8 = 100;
double T8n = 200.0;
double T8e = 100.0;
/* Objecive Function Parameteres*/
double Wa =   1.00;
double Wr =   0.10;
double Wu0=  10.00;
double Wu1=  10.00;
double Wu2=  10.00;
double Wu3=  10.00;
double Wu4= 100.00;
double Wu5= 100.00;
double Wu6= 100.00;
double Wu7= 100.00;
double Wu8= 100.00;
double Wt =  10.00;
/* Startpoint - node 0 parameters */
double startUavSpeed	= 11.2;
double startUavHeading	= 1.0;
double startPosUavNorth = 0.0;
double startPosUavEast	= 0.0;
double startValUncertainty0 = 100.0;
double startValUncertainty1 = 100.0;
double startValUncertainty2 = 100.0;
double startValUncertainty3 = 100.0;
double startValUncertainty4 = 100.0;
double startValUncertainty5 = 100.0;
double startValUncertainty6 = 100.0;
double startValUncertainty7 = 100.0;
double startValUncertainty8 = 100.0;
/* MPC specific parameters */
int loopTest  = 0;
int mpcLoopNr = 1;
int noMpcIter = 10;
int recalcNodeNo =20; // node from wich path is re-optimized from


int	get_loopTest(){
	return loopTest;
}
void set_loopTest(int newLoop){
	loopTest=newLoop;
}
int	get_mpcLoopNr(){
	return mpcLoopNr;
}
void set_incrMpcLoopNr(){
	mpcLoopNr = mpcLoopNr + 1;
}
int	get_noMpcIter(){
	return noMpcIter;
}


/* NLP problem parameteres */
int get_segments(){	// return number of segments in optimization
	return segments;
}
int get_nodes(){	// retuns number of nodes in optimization
	return (get_segments() + 1);
}
int	get_StateVarsNode(){ // returns number of states in state space model
	return StateVarsNode;
}
int	get_InputVarsNode(){ // returns numbe of inputs in state space model
	return InputVarsNode;
}
int	get_OptVarsNode(){ // returns number of optimization variable
	return ( get_StateVarsNode() + get_InputVarsNode() );
}	
int get_noConstr(){	// returns number of constraints
	return ( get_segments()*get_StateVarsNode() );
}
int get_noVar(){	// returns number of optimization variables
	return ( get_nodes()*get_OptVarsNode() );
}
int get_conJacNonZ(){	// returns the number of nonzeros in the constraints jacobian
	return conJacNonZ*get_segments();
}
int get_lagrHessNonZ(){	// returns the number of nonzeros in the Lagrangian function hessian
	int lagr_hessian_nonzeros = HessNonzFirst + HessNonzApp*(get_segments()-1);
	return lagr_hessian_nonzeros;
}
int	get_lagrHessNonzBlock(){ // returns the number of nonzeros in a Lagrangian hessian block
	return HessNonzFirst;
}
int	get_HessNoOverlaps(){ // retunrs number of overlaping elements in Hessian blocks
	return HessNoOverlaps;
}
int	get_HessOverlapIndex(int index){ // returns the index of the indext'th overlaping element
	return HessOverlapIndex[index];
}
double get_grav(){	// returns the value og the gravity parameter
	return grav;
}
double get_T(){		// returns segment length (time in seconds)
	return T;
}
int	get_recalcNodeNo(){
	return recalcNodeNo;
}
/* Disturbances / Updated info */
double get_windSpeedNorth(){
	return windSpeedNorth;
}

/* Uncertainty Model Parameters - Target 0 */

double get_alpha0(){		// returns segment length (time in seconds)
	return alpha0;
}
double get_b0(){		// returns segment length (time in seconds)
	return b0;
}
double get_k0(){		// returns segment length (time in seconds)
	return k0;
}
double get_ceta0(){		// returns segment length (time in seconds)
	return ceta0;
}
double get_T0N(){		// returns segment length (time in seconds)
	return T0n;
}
double get_T0E(){		// returns segment length (time in seconds)
	return T0e;
}
void set_T0N(double newNorth){
	T0n = newNorth;
}	
void set_T0E(double newEast){
	T0e = newEast;
}

/* Uncertainty Model Parameters - Target 1*/

double get_alpha1(){		// returns alpha0 
	return alpha1;
}
double get_b1(){		// returns b1
	return b1;
}
double get_k1(){		// returns k1
	return k1;
}
double get_ceta1(){		// returns ceta1
	return ceta1;
}
double get_T1N(){		// returns North Position of target 1
	return T1n;
}
double get_T1E(){		// returns East Position of target 1
	return T1e;
}
void set_T1N(double newNorth){
	T1n = newNorth;
}	
void set_T1E(double newEast){
	T1e = newEast;
}

/* Uncertainty Model Parameters - Target 2*/

double get_alpha2(){		// returns alpha0 
	return alpha2;
}
double get_b2(){		// returns b1
	return b2;
}
double get_k2(){		// returns k1
	return k2;
}
double get_ceta2(){		// returns ceta1
	return ceta2;
}
double get_T2N(){		// returns North Position of target 1
	return T2n;
}
double get_T2E(){		// returns East Position of target 1
	return T2e;
}
void set_T2N(double newNorth){
	T2n = newNorth;
}	
void set_T2E(double newEast){
	T2e = newEast;
}

/* Uncertainty Model Parameters - Target 3*/
double get_alpha3(){		
	return alpha3;
}
double get_b3(){		
	return b3;
}
double get_k3(){		
	return k3;
}
double get_ceta3(){		
	return ceta3;
}
double get_T3N(){		
	return T3n;
}
double get_T3E(){		
	return T3e;
}
void set_T3N(double newNorth){
	T3n = newNorth;
}	
void set_T3E(double newEast){
	T3e = newEast;
}
/* Uncertainty Model Parameters - Target 4 */
double get_alpha4(){		
	return alpha4;
}
double get_b4(){		
	return b4;
}
double get_k4(){		
	return k4;
}
double get_ceta4(){		
	return ceta4;
}
double get_T4N(){		
	return T4n;
}
double get_T4E(){		
	return T4e;
}
void set_T4N(double newNorth){
	T4n = newNorth;
}	
void set_T4E(double newEast){
	T4e = newEast;
}

/* Uncertainty Model Parameters - Target 5 */
double get_alpha5(){		
	return alpha5;
}
double get_b5(){		
	return b5;
}
double get_k5(){		
	return k5;
}
double get_ceta5(){		
	return ceta5;
}
double get_T5N(){		
	return T5n;
}
double get_T5E(){		
	return T5e;
}
void set_T5N(double newNorth){
	T5n = newNorth;
}	
void set_T5E(double newEast){
	T5e = newEast;
}

/* Uncertainty Model Parameters - Target 6 */
double get_alpha6(){		
	return alpha6;
}
double get_b6(){		
	return b6;
}
double get_k6(){		
	return k6;
}
double get_ceta6(){		
	return ceta6;
}
double get_T6N(){		
	return T6n;
}
double get_T6E(){		
	return T6e;
}
void set_T6N(double newNorth){
	T6n = newNorth;
}	
void set_T6E(double newEast){
	T6e = newEast;
}

/* Uncertainty Model Parameters - Target 7 */
double get_alpha7(){		
	return alpha7;
}
double get_b7(){		
	return b7;
}
double get_k7(){		
	return k7;
}
double get_ceta7(){		
	return ceta7;
}
double get_T7N(){		
	return T7n;
}
double get_T7E(){		
	return T7e;
}
void set_T7N(double newNorth){
	T7n = newNorth;
}	
void set_T7E(double newEast){
	T7e = newEast;
}
/* Uncertainty Model Parameters - Target 8*/
double get_alpha8(){		
	return alpha8;
}
double get_b8(){		
	return b8;
}
double get_k8(){		
	return k8;
}
double get_ceta8(){		
	return ceta8;
}
double get_T8N(){		
	return T8n;
}
double get_T8E(){		
	return T8e;
}
void set_T8N(double newNorth){
	T8n = newNorth;
}	
void set_T8E(double newEast){
	T8e = newEast;
}

/* Objective Functions Wheights */

double get_Wa(){		// returns wheight on ACCELERATION
	return Wa;
} 
double get_Wr(){		// returns wheight on RUDDER/BANK
	return Wr;
} 
double get_Wu0(){		// Returns wheight on UNCERTAINTY 0
	return Wu0;
}
double get_Wu1(){		// Returns wheight on UNCERTAINTY 1
	return Wu1;
} 
double get_Wu2(){		// Returns wheight on UNCERTAINTY 2
	return Wu2;
}
double get_Wu3(){		// Returns wheight on UNCERTAINTY 3
	return Wu3;
} 
double get_Wu4(){		// Returns wheight on UNCERTAINTY 4
	return Wu4;
} 
double get_Wu5(){		// Returns wheight on UNCERTAINTY 5
	return Wu5;
} 
double get_Wu6(){		// Returns wheight on UNCERTAINTY 6
	return Wu6;
} 
double get_Wu7(){		// Returns wheight on UNCERTAINTY 7
	return Wu7;
} 
double get_Wu8(){		// Returns wheight on UNCERTAINTY 8
	return Wu8;
} 
double get_Wt(){		// Returns wheight on Single target
	return Wt;
} 

/* Node 0 Init */
double get_startUavSpeed(){	// returns the value og the gravity parameter
	return startUavSpeed;
}

double get_startUavHeading(){	// returns the value og the gravity parameter
	return startUavHeading;
}
double get_startPosUavNorth(){	// returns the value og the gravity parameter
	return startPosUavNorth;
}
double get_startPosUavEast(){	// returns the value og the gravity parameter
	return startPosUavEast;
}
double get_startValUncertainty0(){	// returns startvalue, uct 0
	return startValUncertainty0;
}
double get_startValUncertainty1(){	// returns the value og the gravity parameter
	return startValUncertainty1;
}
double get_startValUncertainty2(){	// returns startvalue, uct 02
	return startValUncertainty2;
}
double get_startValUncertainty3(){	
	return startValUncertainty3;
}
double get_startValUncertainty4(){	
	return startValUncertainty4;
}
double get_startValUncertainty5(){	
	return startValUncertainty5;
}
double get_startValUncertainty6(){	
	return startValUncertainty6;
}
double get_startValUncertainty7(){	
	return startValUncertainty7;
}
double get_startValUncertainty8(){	
	return startValUncertainty8;
}
void set_startUavSpeed(double newSpeed){
	startUavSpeed = newSpeed;
}
void set_startUavHeading(double newHeading){
	startUavHeading = newHeading;
}
void set_startPosUavNorth(double newUavNorth){
	startPosUavNorth = newUavNorth;
}
void set_startPosUavEast(double newUavEast){
	startPosUavEast = newUavEast;
}
void set_startValUncertainty0(double newUct0){
	startValUncertainty0 = newUct0;
}
void set_startValUncertainty1(double newUct1){
	startValUncertainty1 = newUct1;
}
void set_startValUncertainty2(double newUct2){
	startValUncertainty2 = newUct2;
}
void set_startValUncertainty3(double newUct3){
	startValUncertainty3 = newUct3;
}
void set_startValUncertainty4(double newUct3){
	startValUncertainty3 = newUct3;
}
void set_startValUncertainty5(double newUct3){
	startValUncertainty3 = newUct3;
}
void set_startValUncertainty6(double newUct3){
	startValUncertainty3 = newUct3;
}
void set_startValUncertainty7(double newUct3){
	startValUncertainty3 = newUct3;
}
void set_startValUncertainty8(double newUct3){
	startValUncertainty3 = newUct3;
}