
/*
	Parameters for the optimization problem are gathered here.
	Lars Grimsland, spring 2012
*/

int		get_loopTest();
void	set_loopTest(int newLoop);
int		get_mpcLoopNr();
void    set_incrMpcLoopNr();
int		get_noMpcIter();

/* Problem data */
int		get_StateVarsNode();// returns number of states in state space model
int		get_InputVarsNode();// returns numbe of inputs in state space model
int		get_OptVarsNode();	// returns number of optimization variable
int		get_segments();		// return number of segments in optimization
int		get_nodes();		// retuns number of nodes in optimization
int		get_noConstr();		// returns number of constraints
int		get_noVar();		// returns number of optimization variables for problem
double	get_grav();			// returns the value og the gravity parameter
int		get_conJacNonZ();	// returns the number of nonzeros in the constraints jacobian
int		get_lagrHessNonZ();	// returns the number of nonzeros in the Lagrangian function hessian
int		get_lagrHessNonzBlock(); // returns the number of nonzeros in a Lagrangian hessian block
int		get_HessNoOverlaps(); // number of overlaping elements in Hessian blocks
int		get_HessOverlapIndex(int index); // returns the index of the indext'th overlaping element
double	get_T();			// returns segment length (time in seconds)
int		get_recalcNodeNo();

/* Uncertainty model parameteres - Target 0*/
double	get_alpha0();
double	get_b0();
double	get_k0();
double	get_ceta0();
double	get_T0N();	// returns north coordinate of grid center 0
double	get_T0E();	// returns east coordinate of grid center 0
void	set_T0N(double newNorth);	// returns north coordinate of grid center 0
void	set_T0E(double newEast);	// returns east coordinate of grid center 0

/* Disturbance paramteres */
double get_windSpeedNorth();

/* Uncertainty model parameteres - Target 1*/
double	get_alpha1();
double	get_b1();
double	get_k1();
double	get_ceta1();
double	get_T1N();	// returns north coordinate of grid center 1
double	get_T1E();	// returns east coordinate of grid center 1
void	set_T1N(double newNorth);	// set north coordinate of grid center 1
void	set_T1E(double newEast);	// set east coordinate of grid center 1

/* Uncertainty model parameteres - Target 2*/
double	get_alpha2();
double	get_b2();
double	get_k2();
double	get_ceta2();
double	get_T2N();	// returns north coordinate of grid center 2
double	get_T2E();	// returns east coordinate of grid center 2
void	set_T2N(double newNorth);	// set north coordinate of grid center 2
void	set_T2E(double newEast);	// set east coordinate of grid center 2

/* Uncertainty model parameteres - Target 3 */
double	get_alpha3();
double	get_b3();
double	get_k3();
double	get_ceta3();
double	get_T3N();	// returns north coordinate of grid center 3
double	get_T3E();	// returns east coordinate of grid center 3
void	set_T3N(double newNorth);	// set north coordinate of grid center 3
void	set_T3E(double newEast);	// set east coordinate of grid center 3

/* Uncertainty model parameteres - Target 4 */
double	get_alpha4();
double	get_b4();
double	get_k4();
double	get_ceta4();
double	get_T4N();	// returns north coordinate of grid center 4
double	get_T4E();	// returns east coordinate of grid center 4
void	set_T4N(double newNorth);	// set north coordinate of grid center 4
void	set_T4E(double newEast);	// set east coordinate of grid center 4

/* Uncertainty model parameteres - Target 5 */
double	get_alpha5();
double	get_b5();
double	get_k5();
double	get_ceta5();
double	get_T5N();	// returns north coordinate of grid center 3
double	get_T5E();	// returns east coordinate of grid center 3
void	set_T5N(double newNorth);	// set north coordinate of grid center 3
void	set_T5E(double newEast);	// set east coordinate of grid center 3

/* Uncertainty model parameteres - Target 6 */
double	get_alpha6();
double	get_b6();
double	get_k6();
double	get_ceta6();
double	get_T6N();	// returns north coordinate of grid center 6
double	get_T6E();	// returns east coordinate of grid center 6
void	set_T6N(double newNorth);	// set north coordinate of grid center 6
void	set_T6E(double newEast);	// set east coordinate of grid center 6

/* Uncertainty model parameteres - Target 7 */
double	get_alpha7();
double	get_b7();
double	get_k7();
double	get_ceta7();
double	get_T7N();	// returns north coordinate of grid center 7
double	get_T7E();	// returns east coordinate of grid center 7
void	set_T7N(double newNorth);	// set north coordinate of grid center 7
void	set_T7E(double newEast);	// set east coordinate of grid center 7

/* Uncertainty model parameteres - Target 8 */
double	get_alpha8();
double	get_b8();
double	get_k8();
double	get_ceta8();
double	get_T8N();	// returns north coordinate of grid center 8
double	get_T8E();	// returns east coordinate of grid center 8
void	set_T8N(double newNorth);	// set north coordinate of grid center 8
void	set_T8E(double newEast);	// set east coordinate of grid center 8

/* Objective function parametres*/
double get_Wa();  // returns wheigting (punishments) on input 1, acceleration
double get_Wr();  // returns wheigting (punishments) on input 2, rudder/bank angle
double get_Wu0(); // returns wheigting (punishments) on UNCERTAINTY at target 0
double get_Wu1(); // returns wheigting (punishments) on UNCERTAINTY at target 1
double get_Wu2(); // returns wheigting (punishments) on UNCERTAINTY at target 2
double get_Wu3(); // returns wheigting (punishments) on UNCERTAINTY at target 3
double get_Wu4(); // returns wheigting (punishments) on UNCERTAINTY at target 0
double get_Wu5(); // returns wheigting (punishments) on UNCERTAINTY at target 1
double get_Wu6(); // returns wheigting (punishments) on UNCERTAINTY at target 2
double get_Wu7(); // returns wheigting (punishments) on UNCERTAINTY at target 3
double get_Wu8(); // returns wheigting (punishments) on UNCERTAINTY at target 3
double get_Wt();  // returns wheigting (punishments) on Target Distance

/* Optimization Start point parameteres */
double get_startUavSpeed();
double get_startUavHeading();
double get_startPosUavNorth();
double get_startPosUavEast();
double get_startValUncertainty0();
double get_startValUncertainty1();
double get_startValUncertainty2();
double get_startValUncertainty3();
double get_startValUncertainty4();
double get_startValUncertainty5();
double get_startValUncertainty6();
double get_startValUncertainty7();
double get_startValUncertainty8();

void set_startUavSpeed(double newSpeed);
void set_startUavHeading(double newHeading);
void set_startPosUavNorth(double newUavNorth);
void set_startPosUavEast(double newUavEast);
void set_startValUncertainty0(double newUct0);
void set_startValUncertainty1(double newUct1);
void set_startValUncertainty2(double newUct2);
void set_startValUncertainty3(double newUct3);
void set_startValUncertainty4(double newUct4);
void set_startValUncertainty5(double newUct5);
void set_startValUncertainty6(double newUct6);
void set_startValUncertainty7(double newUct7);
void set_startValUncertainty8(double newUct8);